# Generation Time: Mar 18, 2003 at 05:01 AM
# Server version: 3.23.54
# --------------------------------------------------------

#
# Table structure for table `DeviceValues`
#

CREATE TABLE DeviceValues (
  device smallint(5) unsigned NOT NULL default '0',
  datetime datetime NOT NULL default '0000-00-00 00:00:00',
  temperature float NOT NULL default '0',
  in_temperature float NOT NULL default '0',
  humidity tinyint(3) unsigned NOT NULL default '0',
  in_humidity tinyint(3) unsigned NOT NULL default '0',
  wind_direction smallint(5) unsigned NOT NULL default '0',
  wind_speed tinyint(3) unsigned NOT NULL default '0',
  rain_today float unsigned NOT NULL default '0',
  barometer float unsigned NOT NULL default '0',
  baro_msw float(4,2) NOT NULL default '0.00',
  baro_lsw float(4,2) NOT NULL default '0.00',
  KEY device (device,datetime,temperature,in_temperature,humidity,in_humidity,wind_direction,wind_speed,rain_today)
) TYPE=HEAP COMMENT='Raw Weather Data';

