<?
set_time_limit(120);

function gnuplot_data_line($record) {
	static $last_altitude=0;
	static $last_speed=0;

	$altitude = cvrt($record["altitude"],"mefe",$_REQUEST["metric"]);
	$speed = cvrt($record["speed"],"kmmi",$_REQUEST["metric"]);

	$delta_altitude = $altitude - $last_altitude ;
	$delta_speed = $speed - $last_speed;
	$last_altitude=$altitude;
	$last_speed=$speed;

	$rec = sprintf("%s\t",$record[packet_date]);
	$rec .= sprintf("%d\t", $altitude);
	$rec .= sprintf("%d\t", $speed);
	$rec .= sprintf("%0.2lf\t", $delta_altitude);
	$rec .= sprintf("%0.2lf\t", $delta_speed);
	$rec .="\n";

	return $rec;
}

$call = strtoupper($_REQUEST["call"]);
$show_query = $_REQUEST["show_query"];
$start_date = $_REQUEST["start_date"];
$end_date = $_REQUEST["end_date"];

require $_SERVER["DOCUMENT_ROOT"] . "/world_config.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/metric.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/units.php";

$db = _open_mysql("aprs");


if ( "" == $start_date ) {
	$start_date = sprintf("'%s'",date("Y-m-d",time() - 604800));	/* current date - 1 week */
} else {
	$start_date = "'" . $start_date . "'";
}

if ( "" == $end_date ) {
	$end_date = "now()";
} else {
	$end_date = "'" . $end_date . "'";
}


$sql = sprintf("SELECT packet_date,altitude,speed FROM position WHERE packet_date >= %s AND packet_date <= %s AND source='%s' ORDER BY packet_date",$start_date,$end_date,$call);

$query = mysql_query($sql,$db);

$i=0;

$uniq = md5(uniqid($call));
$dat_filename_path = sprintf("%s/%s-ALTITUDE-%s.dat",WX_TEMP_PATH,$call,$uniq );
$dat_filename_url  = sprintf("%s/%s-ALTITUDE-%s.dat",WX_TEMP_URL, $call,$uniq );
$fp = fopen( $dat_filename_path,"w"); 

$header = sprintf("packet_date\taltitude\tspeed\tdelta_altitude\tdelta_speed\n");
fputs($fp,$header);

while ( $record = mysql_fetch_array($query) ) {
	$i++;

	fputs($fp,gnuplot_data_line($record));
}

fclose($fp);

?>
<DIV ALIGN=CENTER>
<?
$type="altitude";
$this_graph = sprintf("/datamart/gnuplot/gnuplot.php?type=%s&amp;call=%s&amp;units=%s&amp;filename=%s",$type,$call,urlencode(getUnitByName($type,$_REQUEST["metric"])),$dat_filename_path);

?>
	<A HREF="<? echo $this_graph; ?>&amp;debug=1"><IMG SRC="<? echo $this_graph; ?>" ALT="Plot"></A>

	<HR>
<?



$type="speed";
$this_graph = sprintf("/datamart/gnuplot/gnuplot.php?type=%s&amp;call=%s&amp;units=%s&amp;filename=%s",$type,$call,urlencode(getUnitByName($type,$_REQUEST["metric"])),$dat_filename_path);
?>
	<A HREF="<? echo $this_graph; ?>&amp;debug=1"><IMG SRC="<? echo $this_graph; ?>" ALT="Plot"></A>
	<HR>
<?
$type="delta_altitude";
$this_graph = sprintf("/datamart/gnuplot/gnuplot.php?type=%s&amp;call=%s&amp;units=%s&amp;filename=%s",$type,$call,urlencode(getUnitByName($type,$_REQUEST["metric"])),$dat_filename_path);
?>
	<A HREF="<? echo $this_graph; ?>&amp;debug=1"><IMG SRC="<? echo $this_graph; ?>" ALT="Plot"></A>
	<HR>

</DIV>

You can download the data file <A HREF="<? echo $dat_filename_url; ?>"><? echo $dat_filename_url; ?></A> used to generate these graphs. These data are tab seperated and can easily be used with spreadsheets like Gnumeric or Excel. The individual GNUPlot definition files can be downloaded by clicking on the corresponding graph.

