<?
/* APRS Icon Notes:
Primary table symbols cannot have overlays.
*/

function get_icon_name_callsign($call) {
	switch ( $call ) {
	
		default:	return "";
	}

}

function get_icon_img_src($symbol_table,$symbol_code) {
	return getIconImgSrc($symbol_table,$symbol_code);
}

function getIconImgSrc($symbol_table,$symbol_code) {
	if ( $symbol_table == "" || $symbol_code == "" )
		return "";

	if ( $symbol_table != "/" ) {
		$overlay = $symbol_table;
		$symbol_table = "\\";
	} else {
		$overlay="";
	}
	
	return sprintf("<IMG BORDER=0 WIDTH=20 HEIGHT=19 SRC=\"%s/%03d_%03d.png\" ALT=\"%03d_%03d\">%s",SYMBOL_PNG_URL,ord($symbol_table),ord($symbol_code),ord($symbol_table),ord($symbol_code),htmlspecialchars($overlay));
}


function get_icon_name($symbol_table,$symbol_code) {
	return getIconName($symbol_table,$symbol_code);
}

function getIconName($symbol_table,$symbol_code) {
	if ( $symbol_table == "" || $symbol_code == "" )
		return "";
	
	if ( "/" != $symbol_table )
		$symbol_table="\\";

	return sprintf("%03d_%03d",ord($symbol_table),ord($symbol_code));
}


function get_icon_img_path($symbol_table,$symbol_code) {
	return getIconImgPath($symbol_table,$symbol_code);
}
function getIconImgPath($symbol_table,$symbol_code) {

	if ( $symbol_table == "" || $symbol_code == "" )
		return "";

	if ( $symbol_table != "/" ) {
		$overlay = $symbol_table;
		$symbol_table = "\\";
	} else {
		$overlay="";
	}

	return sprintf("%s/%03d_%03d.png",SYMBOL_PNG_PATH,ord($symbol_table),ord($symbol_code));
}

function get_icon_overlay($symbol_table,$symbol_code) {
	return getIconOverlay($symbol_table,$symbol_code);
}

function getIconOverlay($symbol_table,$symbol_code) {

	if ( $symbol_table == "" || $symbol_code == "" )
		return "";

	if ( $symbol_table != '/' ) {
		return $symbol_table;
	} 

	return "";
}

?>
