<?
define("MAX_MAPPED_STATIONS",20);
define("MAX_STATIONS",100);

/* check for multiple calls separated with | symbol */
$calls=explode("|",strtoupper($_REQUEST["call"]));
if ( 1 == count($calls) ) {
	$call=$calls[0];
} else {
	$call = sprintf("%s' OR lastposition.source LIKE ",$calls[0]);
	for ( $i=1 ; $i<count($calls)-1 ; $i++ ) {
		$call .= sprintf("'%s' OR lastposition.source LIKE ",$calls[$i]);
	}
	$call .= sprintf("'%s",$calls[$i]);
}

$emergency_only = $_REQUEST["emergency_only"];
$order = $_REQUEST["order"];
$limit = $_REQUEST["limit"];
$offset = $_REQUEST["offset"];
$sort = $_REQUEST["sort"];
$maps = $_REQUEST["maps"];
$symbol_table = $_REQUEST["symbol_table"];
$symbol_code = $_REQUEST["symbol_code"];
$show_query = $_REQUEST["show_query"];


//$call = strtoupper($call);
if ( $emergency_only )
	$headline=$title="EMERGENCY STATIONS in last 48 hours";
else
	$headline = $title = sprintf("Search results for %s",implode(" or ",$calls));
$subtitle="";
$hr=1;
$refreshable=1; $refresh_period_min=30;
require $_SERVER["DOCUMENT_ROOT"] . "/world_head.php";
include "geoFunctions.php";
include "aprs.class.php";
include "metric.php";
include "units.php";
?>

<DIV ALIGN="center">
Time is in UTC. Coordinates are WGS84. Current date is <? echo gmdate2mysqltime(); ?>.
<?
if ( $metric ) {
	printf("Using metric units.<BR>\n");
} else {
	printf("Using english units.<BR>\n");
}

/* print the javascript required to change zoom levels */
imageReplaceJavascript();
?>


<TABLE WIDTH="90%" CELLPADDING=2 CELLSPACING=2 BORDER=0 BGCOLOR="#e0e0e0">
<TR>
	<TD ID="blank"><!-- Icon --></TD>
	<TH>Callsign</TH>
	<TH>Date</TH>
	<TH>Age</TH>
	<TH>Course</TH>
	<TH>Speed</TH>
	<TH>Altitude</TH>
	<TH>Latitude / Longitude</TH>
	<TH>Status</TH>
</TR>
<!--
see api.php for parameters
-->
<?
require "stopwatch.php";
require "icon.php";

$db = open_mysql("aprs");


if ( $sort == "" )
	$sort = "source";

$sort = "lastposition." . $sort;

if ( $limit == "" )
	$limit = MAX_STATIONS;
if ( $offset == "" )
	$offset = 0;

$order = strtoupper($order);
if ( $order != "DESC" ) {
	$order = "";
}

if ( TRUE == $emergency_only ) {
	$query = sprintf("SELECT lastposition.packet_id, lastposition.packet_date, lastposition.source, lastposition.latitude, lastposition.longitude, lastposition.course, lastposition.speed, lastposition.altitude, lastposition.status, lastposition.symbol_table, lastposition.symbol_code, lastweather.packet_date AS lastweather_packet_date, lastweather.wind_direction, lastweather.wind_speed, lastweather.wind_gust, lastweather.wind_sustained, lastweather.temperature, lastweather.rain_hour, lastweather.rain_calendar_day, lastweather.rain_24hour_day, lastweather.humidity, lastweather.barometer, lastweather.luminosity, laststatus.comment AS laststatus_comment, laststatus.power, laststatus.height, laststatus.gain, laststatus.directivity, laststatus.rate, sec_to_time(unix_timestamp()-unix_timestamp(lastposition.packet_date)) AS packet_age FROM lastposition LEFT JOIN laststatus ON laststatus.source=lastposition.source LEFT JOIN lastweather ON lastweather.source=lastposition.source WHERE lastposition.status LIKE 'EMERGENCY%%' AND (unix_timestamp()-unix_timestamp(lastposition.packet_date)) < 172800 ORDER BY '%s' %s",$sort,$order);
	$maps=TRUE;
} else if ( $symbol_code!="" && $symbol_table!="" ) {
	$query = sprintf("SELECT lastposition.packet_id, lastposition.packet_date, lastposition.source, lastposition.latitude, lastposition.longitude, lastposition.course, lastposition.speed, lastposition.altitude, lastposition.status, lastposition.symbol_table, lastposition.symbol_code, lastweather.packet_date AS lastweather_packet_date, lastweather.wind_direction, lastweather.wind_speed, lastweather.wind_gust, lastweather.wind_sustained, lastweather.temperature, lastweather.rain_hour, lastweather.rain_calendar_day, lastweather.rain_24hour_day, lastweather.humidity, lastweather.barometer, lastweather.luminosity, laststatus.comment AS laststatus_comment, laststatus.power, laststatus.height, laststatus.gain, laststatus.directivity, laststatus.rate, sec_to_time(unix_timestamp()-unix_timestamp(lastposition.packet_date)) AS packet_age FROM lastposition LEFT JOIN laststatus ON laststatus.source=lastposition.source LEFT JOIN lastweather ON lastweather.source=lastposition.source WHERE lastposition.source LIKE '%s' AND lastposition.symbol_table LIKE BINARY '%s' AND lastposition.symbol_code LIKE BINARY '%s' ORDER BY '%s' %s LIMIT %d, %d",$call,$symbol_table,$symbol_code,$sort,$order,$offset,$limit);
	/* BUG ... need to do this */
} else {
//	$query = sprintf("SELECT * FROM lastposition WHERE source LIKE '%s' ORDER BY '%s' %s LIMIT %d,%d",$call,$sort,$order,$offset,$limit);
	$query = sprintf("SELECT lastposition.packet_id, lastposition.packet_date, lastposition.source, lastposition.latitude, lastposition.longitude, lastposition.course, lastposition.speed, lastposition.altitude, lastposition.status, lastposition.symbol_table, lastposition.symbol_code, lastweather.packet_date AS lastweather_packet_date, lastweather.wind_direction, lastweather.wind_speed, lastweather.wind_gust, lastweather.wind_sustained, lastweather.temperature, lastweather.rain_hour, lastweather.rain_calendar_day, lastweather.rain_24hour_day, lastweather.humidity, lastweather.barometer, lastweather.luminosity, laststatus.comment AS laststatus_comment, laststatus.power, laststatus.height, laststatus.gain, laststatus.directivity, laststatus.rate, sec_to_time(unix_timestamp()-unix_timestamp(lastposition.packet_date)) AS packet_age FROM lastposition LEFT JOIN laststatus ON laststatus.source=lastposition.source LEFT JOIN lastweather ON lastweather.source=lastposition.source WHERE lastposition.source LIKE '%s' ORDER BY '%s' %s LIMIT %d, %d",$call,$sort,$order,$offset,$limit);
}


if ( $show_query )
	printf("MySQL = %s<BR>\n",$query);

ss_timing_start();
$q1 = mysql_query($query,$db);
ss_timing_stop();

$i=0;
while ( $record = mysql_fetch_array($q1) ) {
	$data[$i]["source"] = $record["source"];
	$data[$i]["packet_date"] = $record["packet_date"];
	$data[$i]["packet_age"] = $record["packet_age"];
	$data[$i]["packet_id"] = $record["packet_id"];
	$data[$i]["symbol_table"] = $record["symbol_table"];
	$data[$i]["symbol_code"] = $record["symbol_code"];
	$data[$i]["course"] = $record["course"];
	$data[$i]["speed"] = $record["speed"];
	$data[$i]["altitude"] = $record["altitude"];
	$data[$i]["latitude"] = $record["latitude"];
	$data[$i]["longitude"] = $record["longitude"];
	$data[$i]["status"] = humanStatus($record,$metric) . $record["status"];
	$data[$i]["icon"] = get_icon_name($record["symbol_table"],$record["symbol_code"]);
	
	$i++;
}

$records = count($data);
for ( $i=0 ; $i < $records ; $i++ ) {

$sc="";
if ( $data[$i]["speed"] != "" && $data[$i]["speed"] > 0 ) {
	$sc = "station_moving";
}
if ( (time() - mysqltime2unixtime($data[$i]["packet_date"])) > (60*80) ) {
	$sc = "station_old";
}
if ( FALSE != strstr($data[$i]["status"],"EMERGENCY") ) {
	$sc = "station_emergency";
}

?>	  
<TR>

	<TD CLASS="<? echo $sc; ?>" ALIGN="center"><? echo get_icon_img_src($data[$i]["symbol_table"],$data[$i]["symbol_code"]); ?></TD>
	<TD ALIGN="center"><? echo $data[$i]["source"]; ?></TD>
	<TD ALIGN="center"><? echo $data[$i]["packet_date"]; ?></TD>
	<TD ALIGN="center"><? echo $data[$i]["packet_age"]; ?></TD>
	<TD ALIGN="center"><? 
if ( $data[$i][course] ) {
	printf("%03d&deg; %s",$data[$i]["course"],courseToCardinal($data[$i]["course"]));
}
?>
	</TD>
	<TD ALIGN="center"><? 
if ( $data[$i][speed] ) {
	printf("%02d",cvrt($data[$i]["speed"],"kmmi",$metric));
} 
?>
	</TD>
	<TD ALIGN="center"><? 

if ( $data[$i][altitude] ) {
	printf("%d",cvrt($data[$i]["altitude"],"mefe",$metric));
}
?></TD>
	<TD ALIGN="center"><? 
if ( $data[$i]["latitude"] != 0 && $data[$i]["longitude"] != 0 ) {
	printf("%2.4lf %2.4lf (%s)",$data[$i]["latitude"],$data[$i]["longitude"],maidenhead($data[$i]["latitude"],$data[$i]["longitude"])); 
}
?></TD>
	<TD>
		<? 
		echo urlToClickable($data[$i]["status"]);
		?>
	</TD>
</TR>
<?
if ( FALSE != strstr($data[$i]["status"],"EMERGENCY") ) {
?>
<TR CLASS="highlightone">
	<TD COLSPAN=9>
		<DIV ALIGN=CENTER>
			<B>EMERGENCY</B>
		</DIV>
	</TD>
</TR>
<?
}

if ( $maps && $records<=MAX_MAPPED_STATIONS ) {
?>
<TR> 
		<TD COLSPAN=9 ALIGN=CENTER>
		<? mapserverScaleableMap($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["source"],$data[$i]["icon"]); ?>
		</TD>

</TR>
<?
}
if ( FALSE != strstr($data[$i]["status"],"EMERGENCY") ) {
?>
<TR CLASS="highlightone">
	<TD COLSPAN=9>
		<DIV ALIGN=CENTER>
			<B>EMERGENCY</B>
		</DIV>
	</TD>
</TR>
<?
}
?>
<TR>
	<TD COLSPAN=9>
<TABLE WIDTH="100%" BORDER=0>

	<TR CLASS="highlighttwo">
		<TD ALIGN="right">Geospatial:</TD>
		<TD COLSPAN=2>
<? echo getOutsideMapList($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["source"]); ?>
		</TD>
		<TD>
<A HREF="<? echo gazClosestPointUrl($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["source"]); ?>">Closest City</A>
		</TD>
		<TD>
<A HREF="<? echo getGeocodeLink($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["packet_id"]); ?>">GeoCode</A>
		</TD>
	</TR>
	<TR CLASS="highlighttwo">
		<TD ALIGN="right">Radio:</TD>
		<TD>
<A HREF="<? echo trackCall($data[$i]["source"]); ?>">Track</A>
		</TD>
		<TD>
<A HREF="<? echo datamartCloseStations($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["source"]); ?>">Nearby Stations</A>
		</TD>
		<TD>
<A HREF="<? echo rawTncUrl($data[$i]["packet_id"]); ?>">Raw Packet</A>
		</TD>
		<TD>
<A HREF="<? echo getQrzLink($data[$i]["source"]); ?>">QRZ Lookup</A>
		</TD>
		<TD>
<A HREF="<? echo getHopsUrl($data[$i]["source"]); ?>">Show hops to IGATE for area</A>
		</TD>
	</TR>
</TABLE>
	</TD>
</TR>
<?
}
?>
<TR>
	<TH COLSPAN=9>There were <? echo $i; ?> records found in <? printf("%1.4lf",ss_timing_current()); ?> seconds.</TH>
</TR>
</TABLE>
</DIV>
<?
if ( $i >= MAX_STATIONS ) {
?>
<P>
<H3>Maximum number of stations displayed</H3>
There is a limit of <? echo MAX_STATIONS; ?> stations per page displayed. Please try refining your search criteria.

<?
}

if ( $maps && $i>=MAX_MAPPED_STATIONS ) {
?>
<P>
<H3>Maps not Shown</H3>
You requested maps be shown, however there were more than 20 stations found. Maps can only be shown if there are 20 or less stations displayed. Please refine your search query.
<?
}

if ( $i > 0 ) {
?>
<P>
<H3>Icon Colors</H3>
The color behind the station icon represents the stations status. An emergency station will have a red background, a moving station will have a yellow background, a static station will have a white background, and an old station will have a grey background. If the icon has a black background then you are likely using a Microsoft browser product that <A HREF="http://support.microsoft.com/default.aspx?scid=kb;en-us;Q294714">does not understand transparent PNG</A> files. Perhaps you could try a broswer like <A HREF="http://www.mozilla.org">Mozilla</A>.

<?
}
?>

<? 
require $_SERVER["DOCUMENT_ROOT"] . "/world_foot.php";
?>
