<?
$title = "Packet Statistics";
$headline = "Packet Statistics";
require "./world_head.php";
?>
<TABLE BORDER=0 CELLPADDING=3>
<TR><TD VALIGN="top">

<TABLE BORDER=0>
<TR><TH>State</TH><TH>Position Packets</TH><TH>Percent</TH></TR>
<?

function jmax($array) {
$max_val=0;
for ($i=0 ; $i<sizeof($array) ; $i++ ) {
	if ( abs($array[$i]) > abs($max_val) ) {
		$max_val=$array[$i];
	}
}
return $max_val;
}

$fp = @fopen("/tmp/count","r");

if ( $fp ):

$i=0;
while ( $line = fgets($fp,1024) ) {
	$record = explode(" ",$line);
	$count[$record[0]] = $record[1];
}


//printf("MAX=%d MIN=%d\n",jmax($count),min($count));
$states = array( 1=>"Alabama", 2=>"Alaska", 4=>"Arizona ", 5=>"Arkansas ", 6=>"California ", 8=>"Colorado ", 9=>"Connecticut ", 10=>"Delaware ", 11=>"District of Columbia", 12=>"Florida ", 13=>"Georgia ", 15=>"Hawaii ", 16=>"Idaho ", 17=>"Illinois", 18=>"Indiana", 19=>"Iowa ", 20=>"Kansas ", 21=>"Kentucky", 22=>"Louisiana ", 23=>"Maine ", 24=>"Maryland ", 25=>"Massachusetts ", 26=>"Michigan ", 27=>"Minnesota ", 28=>"Mississippi ", 29=>"Missouri", 30=>"Montana ", 31=>"Nebraska", 32=>"Nevada ", 33=>"New Hampshire ", 34=>"New Jersey ", 35=>"New Mexico ", 36=>"New York ", 37=>"North Carolina ", 38=>"North Dakota ", 39=>"Ohio", 40=>"Oklahoma", 41=>"Oregon ", 42=>"Pennsylvania ", 44=>"Rhode Island ", 45=>"South Carolina ", 46=>"South Dakota ", 47=>"Tennessee ", 48=>"Texas ", 49=>"Utah ", 50=>"Vermont ", 51=>"Virginia ", 53=>"Washington ", 54=>"West Virginia ", 55=>"Wisconsin ", 56=>"Wyoming ", 72=>"Puerto Rico" );
$rainbow = array("#ffff00","#ffce00","#ff9900","#ff6500","#ff3000");
$step = jmax($count) / 4;
$max = jmax($count);
$total = array_sum($count);

arsort($count,SORT_NUMERIC);
reset($count);

$rank=1;
while (list ($state_fips, $packets) = each ($count)) {
	
	if ( $packets > 0 ) {
		/* continuosly scale the colors from yellow to red, or if zero then make them gray */
		$r=255;
		$g=round(255-($packets/$max)*255);
		$b=00;
		} else {
		$r=242; $g=242; $b=242;
		}

	if ( $states[$state_fips] != "" ) {
		printf("<TR BGCOLOR=\"%02x%02x%02x\"><TD><FONT SIZE=-1>%d</FONT> %s</TD><TD ALIGN=\"right\">%d</TD><TD>%.02f%%</TD></TR>\n",$r,$g,$b,$rank,$states[$state_fips],$packets,($packets / $total)*100.0);
		$rank++;
	}

}

else:
printf("<TR BGCOLOR=\"GREEN\"><TH COLSPAN=3>Error reading /tmp/count</TH></TR>\n");
endif;




?>
</TABLE>
</TD>
<TD VALIGN="top"><!-- Second Column-->
<DIV ALIGN="center">
<A HREF = "http://brain-dead.dhs.org/stats-map.php"><IMG BORDER=0 SRC="http://brain-dead.dhs.org/test.gif"></A>
</DIV>
<P>

<?
printf("There were %d packets in the United States used for these statistics.<BR>\n",$total);

?>
Statistics were generated by selecting all position packets over a one day period starting <B><? echo $start_date; ?></B>. All positions were run through a point in polygon check using a shapefile that defines each state in the US as a polygon. All of the packets in each state were then added together to give the number in the second column of the table. Percent of indicated packets from state divied by the sum of all states packets times 100.
<P>
The color of each row of the table is dynamically recalculated each time the statistics are generated. The green value of the 8-bit RGB color is calculated by the following formula: <B>round(255-($packets_in_this_state / $max_packets_in_any_state)*255)</B>
<P>
These numbers represent the position packets that I was able to parse, not the whole internet stream. The whole internet stream consists of about 600,000 packets a day, but only about 500,000 of those are position packets. Please see <A HREF = "/info/database-limitations.php"> system limitations</A> for more information about the capabilities and limitations of this database.
<P>
If someone can supply me with a low resolution world political basemap, in ESRI shapefile format, I would love to generate statistics by country. I think <A HREF = "http://gisstore.esri.com/acb/showdetl.cfm?&DID=6&Product_ID=314&CATID=15">ESRI's Digital Chart of the World</A> CD would have it. Shapefile would be prefered, but I can generate a shapefile from discrete lat/lon vertex points. The state shapefile has about 14,000 vertices in it. 

</TD>
</TR>
</TABLE>
<?
require "world_foot.php";
?>
