<?
$call = strtoupper($call);
$headline = $title = sprintf("Places near %s (%s,%s)",$name,$lat,$lon);
$hr=1;
require "../world_head.php";
include "geoFunctions.php";
?>
<DIV ALIGN="center">
<? if ($feature_type != "" || $limit == 1 ) 
	printf("<A HREF = \"%s\">Relax query to show more results.</A>\n<P>\n",gazClosestPointUrl($lat,$lon,$name,100,""));
?>
<TABLE WIDTH=90% CELLPADDING=2 CELLSPACING=2 BORDER=0 BGCOLOR="#000099">
<TR>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Name</FONT></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Type</FONT></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Political Entity</FONT></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Lat/Lon</FONT></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Distance</FONT></TH>
</TR>
<!--
$lat		Latitude to be near
$lon 		Longitude to be near
$bbox_size	Size of search area
$sort		column to order by, default source
$limit	maximum number of results to show, default 100
$offset	record to start at
$show_query	if 1 then show query
-->
<?
require "stopwatch.php";
require "icon.php";
require "../gaz/feature_type.php";

$db = open_mysql("gaz");

ss_timing_start();

if ( $sort == "" )
	$sort = "source";
if ( $limit == "" )
	$limit = 100;
if ( $offset == "" )
	$offset = 0;
if ( $bbox_size == "" )
	$bbox_size = .1;
if ( $feature_type != "" )
	$feature_sql = "AND feature_type=\"" . $feature_type . "\" ";
	

$queries=0;
$max_size = $bbox_size;
$bbox_size = 0.1;
do {
	/* Put us in the right hemisphere */
	if ( $lat < 0 ) {
		$lat1 = $lat - $bbox_size;
		$lat2 = $lat + $bbox_size;
		$lat1_sign = ">=";
		$lat2_sign = "<=";
	} else {
		$lat1 = $lat + $bbox_size;
		$lat2 = $lat - $bbox_size;
		$lat1_sign = "<=";
		$lat2_sign = ">=";
	}
	if ( $lon < 0 ) {
		$lon1 = $lon - $bbox_size;
		$lon2 = $lon + $bbox_size;
		$lon1_sign = ">=";
		$lon2_sign = "<=";
	} else {
		$lon1 = $lon + $bbox_size;
		$lon2 = $lon - $bbox_size;
		$lon1_sign = "<=";
		$lon2_sign = ">=";
	}


	$query = sprintf("SELECT location.feature_name, location.latitude, location.longitude, location.feature_type, state_alpha.full AS state FROM location LEFT JOIN state_alpha ON location.state_alpha=state_alpha.state_alpha WHERE (latitude %s %s AND latitude %s %s) AND (longitude %s %s AND longitude %s %s) %s LIMIT %d\n",$lat1_sign,$lat1,$lat2_sign,$lat2,$lon1_sign,$lon1,$lon2_sign,$lon2,$feature_sql,200);

	if ( 1 == $show_query ) {
		printf("MySQL = %s<BR>\n",$query);
		printf("bbox_size = %s<BR>\n",$bbox_size);
	}

	$q1 = mysql_query($query,$db);
	$queries++;

	$bbox_size += 0.1;
} while ( (0 == mysql_num_rows($q1)) && ($bbox_size <= $max_size) );

$i=0;
while ( $record = mysql_fetch_array($q1) )
	{
	$data[$i]["feature_name"] = $record["feature_name"];
	$data[$i]["latitude"] = $record["latitude"];
	$data[$i]["longitude"] = $record["longitude"];
	$data[$i]["feature_type"] = $record["feature_type"];
	$data[$i]["political_entity"] = $record["state"];
	$data[$i]["arcLength"] = arcLength($lat,$lon,$data[$i]["latitude"],$data[$i]["longitude"]);
	$i++;
}

if ( $i == 0 )	{
	/* We still haven't found any records. Let's try the NIMA database */
	$bbox_size = 0.1;
	do {
		/* Put us in the right hemisphere */
		if ( $lat < 0 ) {
			$lat1 = $lat - $bbox_size;
			$lat2 = $lat + $bbox_size;
			$lat1_sign = ">=";
			$lat2_sign = "<=";
		} else {
			$lat1 = $lat + $bbox_size;
			$lat2 = $lat - $bbox_size;
			$lat1_sign = "<=";
			$lat2_sign = ">=";
		}
		if ( $lon < 0 ) {
			$lon1 = $lon - $bbox_size;
			$lon2 = $lon + $bbox_size;
			$lon1_sign = ">=";
			$lon2_sign = "<=";
		} else {
			$lon1 = $lon + $bbox_size;
			$lon2 = $lon - $bbox_size;
			$lon1_sign = "<=";
			$lon2_sign = ">=";
		}


		$query = sprintf("SELECT nima.feature_name, nima.latitude, nima.longitude, nima.feature_type, country_fips.full AS country FROM nima LEFT JOIN country_fips ON nima.country_fips=country_fips.country_fips WHERE (latitude %s %s AND latitude %s %s) AND (longitude %s %s AND longitude %s %s) LIMIT %d\n",$lat1_sign,$lat1,$lat2_sign,$lat2,$lon1_sign,$lon1,$lon2_sign,$lon2,200);

		if ( 1 == $show_query ) {
			printf("MySQL = %s<BR>\n",$query);
			printf("bbox_size = %s<BR>\n",$bbox_size);
		}
	
		$q1 = mysql_query($query,$db);
		$queries++;
	
		$bbox_size += 0.1;
	} while ( (0 == mysql_num_rows($q1)) && ($bbox_size <= $max_size) );

	$i=0;
	while ( $record = mysql_fetch_array($q1) )
		{
		$data[$i]["feature_name"] = $record["feature_name"];
		$data[$i]["latitude"] = $record["latitude"];
		$data[$i]["longitude"] = $record["longitude"];
		$data[$i]["feature_type"] = $record["feature_type"];
		$data[$i]["political_entity"] = $record["country"];
		$data[$i]["arcLength"] = arcLength($lat,$lon,$data[$i]["latitude"],$data[$i]["longitude"]);
		$i++;
	}
}

function sortByDistance($a, $b ) {
	if ( $a["arcLength"] == $b["arcLength"] )
		return 0;
	if ( $a["arcLength"] > $b["arcLength"] )
		return 1;
	if ( $a["arcLength"] < $b["arcLength"] )
		return -1;
}

if ( $i > 0 ) {
usort($data, sortByDistance);

$records = count($data);
for ( $i=0 ; $i < $records && $i<$limit ; $i++ ) {

	if ( $i > 0 && ( $data[$i]["feature_name"] == $data[$i-1]["feature_name"] && $data[$i]["latitude"] == $data[$i-1]["latitude"] ) )
		continue;
?>	  
<TR BGCOLOR="#ffffff">

	<TH ALIGN="center"><? echo $data[$i]["feature_name"]; ?></font></TH>
	<TD ALIGN="center"><? echo feature_type($data[$i][feature_type]); ?></TD>
	<TD ALIGN="center"><? echo $data[$i]["political_entity"]; ?></TD>
	<TD ALIGN="center"><? 
if ( $data[$i]["latitude"] == 0 && $data[$i]["longitude"] == 0 ) {
	printf("???,???"); 
	} else { 
	printf("%2.4lf,%2.4lf",$data[$i]["latitude"],$data[$i]["longitude"]); 
	}
?></TD>
	<TD BGCOLOR="white" ALIGN="center"><? printf("%.2fmi",$data[$i]["arcLength"]); ?></TD>
</TR>
<TR BGCOLOR="white">
	<TD COLSPAN=7>
	<TABLE WIDTH=100%><TR>
		<TD><A HREF="<? echo mapblastPointUrl($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["feature_name"]); ?>">Mapblast Map</A></TD>
		<TD><A HREF="<? echo mapserverPointUrl($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["feature_name"]); ?>">Mapserver Map</A></TD>
	</TR></TABLE>
</TR>
<?
} 
ss_timing_stop();
?>
<TR>
	<TD COLSPAN=7><FONT COLOR="white">There were <? echo $i; ?> records found in <? printf("%1.4lf",ss_timing_current()); ?> seconds, requiring <? echo $queries; ?> queries.</FONT></TD>
<?
} else {
	printf("</TR><TR BGCOLOR=\"white\"><TH COLSPAN=5>No records found!</TH>\n");
}
?>
</TR>
</TABLE>
</DIV>
<?
require "../world_foot.php";
?>
