<?
$call = strtoupper($call);
$headline = $title = sprintf("Stations near %s (%s,%s)",$name,$lat,$lon);
$hr=1;
require "../world_head.php";
include "geoFunctions.php";
?>

<DIV ALIGN="center">
<TABLE WIDTH=90% CELLPADDING=2 CELLSPACING=2 BORDER=0 BGCOLOR="#000099">
<TR>
	<TH><!-- Icon --></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Callsign</FONT></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Date</FONT></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Course / Speed / Altitude</FONT></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Lat/Lon (WGS84)</FONT></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Status</FONT></TH>
	<TH><FONT FACE="arial,helvetica" SIZE=-1 COLOR="#ffffff">Distance</FONT></TH>
</TR>
<!--
$lat		Latitude to be near
$lon 		Longitude to be near
$bbox_size	Size of search area
$sort		column to order by, default source
$limit	maximum number of results to show, default 100
$offset	record to start at
$show_query	if 1 then show query
-->
<?
require "stopwatch.php";
require "icon.php";

$db = open_mysql("aprs");

ss_timing_start();

if ( $sort == "" )
	$sort = "source";
if ( $limit == "" )
	$limit = 100;
if ( $offset == "" )
	$offset = 0;
if ( $bbox_size == "" )
	$bbox_size = .5;

/* Put us in the right hemisphere */
if ( $lat < 0 ) {
	$lat1 = $lat - $bbox_size;
	$lat2 = $lat + $bbox_size;
	$lat1_sign = ">=";
	$lat2_sign = "<=";
} else {
	$lat1 = $lat + $bbox_size;
	$lat2 = $lat - $bbox_size;
	$lat1_sign = "<=";
	$lat2_sign = ">=";
}
if ( $lon < 0 ) {
	$lon1 = $lon - $bbox_size;
	$lon2 = $lon + $bbox_size;
	$lon1_sign = ">=";
	$lon2_sign = "<=";
} else {
	$lon1 = $lon + $bbox_size;
	$lon2 = $lon - $bbox_size;
	$lon1_sign = "<=";
	$lon2_sign = ">=";
}

$query = sprintf("SELECT * FROM lastposition WHERE (latitude %s %s AND latitude %s %s) AND (longitude %s %s AND longitude %s %s) LIMIT %d\n",$lat1_sign,$lat1,$lat2_sign,$lat2,$lon1_sign,$lon1,$lon2_sign,$lon2,$limit);


if ( 1 == $show_query )
	printf("MySQL = %s<BR>\n",$query);

$q1 = mysql_query($query,$db);

$i=0;
while ( $record = mysql_fetch_array($q1) )
	{
	$data[$i]["source"] = $record["source"];
	$data[$i]["packet_date"] = $record["packet_date"];
	$data[$i]["symbol_table"] = $record["symbol_table"];
	$data[$i]["symbol_code"] = $record["symbol_code"];
	$data[$i]["course"] = $record["course"];
	$data[$i]["speed"] = $record["speed"];
	$data[$i]["altitude"] = $record["altitude"];
	$data[$i]["latitude"] = $record["latitude"];
	$data[$i]["longitude"] = $record["longitude"];
	$data[$i]["status"] = $record["status"];
	$data[$i]["arcLength"] = arcLength($lat,$lon,$data[$i]["latitude"],$data[$i]["longitude"]);
	$i++;
}

function sortByDistance($a, $b ) {
	if ( $a["arcLength"] == $b["arcLength"] )
		return 0;
	if ( $a["arcLength"] > $b["arcLength"] )
		return 1;
	if ( $a["arcLength"] < $b["arcLength"] )
		return -1;
}

usort($data, sortByDistance);

$records = count($data);
for ( $i=0 ; $i < $records ; $i++ ) {
?>	  
<TR BGCOLOR="#ffffff">

	<TD BGCOLOR="white" ALIGN="center"><? echo get_icon_img_src($data[$i]["symbol_table"],$data[$i]["symbol_code"]); ?></TD>
	<TH ALIGN="center"><? echo $data[$i]["source"]; ?></font></TH>
	<TD ALIGN="center"><? echo $data[$i]["packet_date"]; ?></TD>
	<TD ALIGN="center"><? 
if ( $data[$i][course] ) {
	printf("%03d /",$data[$i]["course"]);
} else {
	printf("??? /");
}

if ( $data[$i][speed] ) {
	printf(" %02d /",$data[$i]["speed"]);
} else {
	printf(" ??? /");
}

if ( $data[$i][altitude] ) {
	printf(" %d",$data[$i]["altitude"]);
} else {
	printf(" ???");
}
?></TD>
	<TD ALIGN="center"><? 
if ( $data[$i]["latitude"] == 0 && $data[$i]["longitude"] == 0 ) {
	printf("???,???"); 
	} else { 
	printf("%2.4lf,%2.4lf",$data[$i]["latitude"],$data[$i]["longitude"]); 
	}
?></TD>
	<TD BGCOLOR="white"><? echo $data[$i]["status"]; ?></TD>
	<TD BGCOLOR="white" ALIGN="center"><? printf("%.2fmi",$data[$i]["arcLength"]); ?></TD>
</TR>
<TR BGCOLOR="white">
	<TD COLSPAN=7>
	<TABLE WIDTH=100%><TR>
		<TD><A HREF="<? echo mapblastPointUrl($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["source"]); ?>">Mapblast Map</A></TD>
		<TD><A HREF="<? echo gazClosestPointUrl($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["source"]) . "&table=location"; ?>">Closest City</A></TD>
		<TD><A HREF="<? echo mapserverPointUrl($data[$i]["latitude"],$data[$i]["longitude"],$data[$i]["source"]); ?>">Mapserver Map</A></TD>
		<TD><A HREF="<? echo trackCall($data[$i]["source"]); ?>">Track</A></TD>
	</TR></TABLE>
</TR>
<?
}
ss_timing_stop();
?>
<TR>
	<TD COLSPAN=7><FONT COLOR="white">There were <? echo $i; ?> records found in <? printf("%1.4lf",ss_timing_current()); ?> seconds.</FONT></TD>
</TR>
</TABLE>
</DIV>
<? 
require "../world_foot.php";
?>
