#include <stdio.h>
#include <math.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

int main(void)
{
double latitude;
double longitude;
char information[256] = "=/5L!!<*e7>7P[";
char *p = information;
char symbol_table;
char symbol_code;
int course_made_true;
int speed_over_ground;

printf("Incomming information: %s\n",information);
p++;
printf("%s\n",p);

symbol_table = p[0];
symbol_code = p[9];

latitude = 90 - ( ((int)p[1]-33)*753571 + ((int)p[2]-33)*8281 + ((int)p[3]-33)*91 + ((int)p[4]-33) ) / 380926.0;

longitude = -180 + ( ((int)p[5]-33)*753571 + ((int)p[6]-33)*8281 + ((int)p[7]-33)*91 + ((int)p[8]-33) ) / 190463.0;


if (	p[9] >= '!' && p[9] <= 'z' &&
		p[10] >= '!' && p[10] <= 'z' ) 
	{
	course_made_true = (p[9]-33) * 4;
	speed_over_ground = pow(1.08,(p[10]-33))-1;
	} else {
	course_made_true=0;
	speed_over_ground=0;
}


printf("Symbol Table: %c\n",symbol_table);
printf("Symbol Code: %c\n",symbol_code);
printf("Latitude: %lf\n",latitude);
printf("Longitude: %lf\n",longitude);
printf("Course Made True: %d\n",course_made_true);
printf("Speed Over Ground: %d\n",speed_over_ground);

return 0;
}
