<?

class Aprsworld_raw {
	var $db;
	var $packet_id;
	var $packet_time;
	var $ip_source;
	var $source;
	var $destination;
	var $digis;
	var $information;

	/* constructor */
	function Aprsworld_raw($db,$packet_id) {

		$this->digis = array();

		$this->db = $db;

		$sql = sprintf("SELECT * FROM raw WHERE packet_id=%d",$packet_id);

		$q1 = mysql_query($sql,$db);

		$res = mysql_fetch_array($q1);

		$this->packet_id = $res["packet_id"];
		$this->packet_time = $res["packet_time"];
		$this->ip_source = $res["ip_source"];
		$this->source = $res["source"];
		$this->destination = $res["destination"];
		$this->information = $res["information"];

		$this->digi[0] = $res["digipeater_0"];
		$this->digi[1] = $res["digipeater_1"];
		$this->digi[2] = $res["digipeater_2"];
		$this->digi[3] = $res["digipeater_3"];
		$this->digi[4] = $res["digipeater_4"];
		$this->digi[5] = $res["digipeater_5"];
		$this->digi[6] = $res["digipeater_6"];
		$this->digi[7] = $res["digipeater_7"];
	}

	function tnc() {
		$ret = sprintf("%s>%s",$this->source,$this->destination);

		$i=0;
		while ( "" != $this->digi[$i] ) {
			$ret .= sprintf(",%s",$this->digi[$i]);
			$i++;
		}

		$ret .= sprintf(":%s",$this->information);
		
		return $ret;
	}

	function tnc_html_color() {
		$ret = sprintf("<FONT COLOR=RED>%s&gt;</FONT><FONT COLOR=ORANGE>%s</FONT>",$this->source,$this->destination);

		$i=0;
		$ret .= "<FONT COLOR=BLUE>";
		while ( "" != $this->digi[$i] ) {
			$ret .= sprintf(",%s",$this->digi[$i]);
			$i++;
		}

		$ret .= sprintf(":</FONT><FONT COLOR=GREEN>%s</FONT>",htmlspecialchars($this->information));
		
		return $ret;
	}

}

	

class Aprsworld_position {
	var $db;

	var $packet_id=0;
	var $source="";
	var $time_of_fix=0;
	var $packet_date=0;
	var $latitude=0;
	var $longitude=0;
	var $course=0;
	var $speed=0;
	var $altitude=0;
	var $status="";
	var $symbol_table="";
	var $symbol_code="";

	/* constructor */
	function Aprsworld_position($db) {
		$this->db = $db;
	}

	/* special functions to support serialization */
	/*
	function __sleep() {
		printf("This class probably should be serialized due to the dynamic nature of the database ");
	}

	function __sleep() {
		printf("WARNING: Information may be stale. Re-run query for current results");
	}
	*/

	/** get position based on packet_id
	 * @param packet_id unique database identifier
	 */
	function get_position($packet_id=0) {
		if ( 0 == $packet_id )
			return -1;

		$sql = sprintf("SELECT *,from_unixtime(time_of_fix) as packet_date FROM position WHERE packet_id=%d",$packet_id);
		
		$q1 = mysql_query($sql,$this->db);

		$record = mysql_fetch_array($q1);

		printf("time_of_fix: %s packet_date: %s<BR>\n",$record["time_of_fix"],$record["packet_date"]);

		$this->packet_id = $record["packet_id"];
		$this->time_of_fix = $record["time_of_fix"];
		$this->packet_date = $record["packet_date"];
		$this->source = $record["source"];
		$this->latitude = $record["longitude"];
		$this->longitude = $record["latitude"];
		$this->course = $record["course"];
		$this->speed = $record["speed"];
		$this->altitude = $record["altitude"];

		/* unused, initialize */
		$this->status = "";
		$this->symbol_table = "";
		$this->symbol_code = "";
	}

	function get_last_position($source="") {
		if ( "" == $source )
			return -1;

		$sql = sprintf("SELECT *,unix_timestamp(packet_date) as time_of_fix FROM lastposition WHERE source='%s'",$source);
		
		$q1 = mysql_query($sql,$this->db);

		$record = mysql_fetch_array($q1);

		$this->packet_id = $record["packet_id"];
		$this->source = $record["source"];
		$this->time_of_fix = $record["time_of_fix"];
		$this->packet_date = $record["packet_date"];
		$this->latitude = $record["longitude"];
		$this->longitude = $record["latitude"];
		$this->course = $record["course"];
		$this->speed = $record["speed"];
		$this->altitude = $record["altitude"];
		$this->status = $record["status"];
		$this->symbol_table = $record["symbol_table"];
		$this->symbol_code = $record["symbol_code"];
	}

	

	/* get functions, because accessing the data members directly is bad or something (darn WSU)*/
	function get_source() {
		return $this->source;
	}

	function get_packet_id() {
		return $this->packet_id;
	}

	function get_latitude() {
		return $this->latitude;
	}

	function get_longitude() {
		return $this->longitude;
	}

	function get_time_of_fix() {
		return $this->time_of_fix;
	}

	function get_packet_date() {
		return $this->packet_date;
	}


}


function class_test() {
$db = mysql_connect("localhost","root","roadtoad");
mysql_select_db("aprs",$db);

$pos = new Aprsworld_position($db);
?>
Position with packet_id=18:<BR>

<?

$pos->get_position(18);
printf("Source: %s Latitude: %s Longitude: %s<BR>\n",$pos->get_source(),$pos->latitude,$pos->longitude);
printf("Time_of_fix: %s Packet Date: %s<BR>\n",$pos->get_time_of_fix(),$pos->get_packet_date());

?>
<P>
Last position:<BR>

<?


$pos->get_last_position("KB0THN-7");
printf("Source: %s Latitude: %s Longitude: %s<BR>\n",$pos->get_source(),$pos->latitude,$pos->longitude);
printf("Time_of_fix: %s Packet Date: %s<BR>\n",$pos->get_time_of_fix(),$pos->get_packet_date());
?>
<P>
Raw stuff
<P>
<?
$packet_id = $pos->get_packet_id();;

for ( $packet_id=1000 ; $packet_id < 1200 ; $packet_id++ ) {
	$raw = new Aprsworld_raw($db,$packet_id);
	printf("%s<BR>\n",$raw->tnc_html_color());
}

}
?>
