set term png color
set offsets
set nolog
set nopolar
set border
set grid
set title "Change in Altitude of ##CALL##"
set xlabel "Date / Time"
set ylabel "##UNITS##"
set size ##SIZE## 
set missing "NULL"

set xdata time
set format x "%m/%d"
set timefmt "%Y-%m-%d %H:%M:%S"
plot "##DATAFILE_PATH##" using 1:##COLUMN## title "" with impulses

