<?
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
header("Cache-Control: no-cache, must-revalidate"); // for HTTP/1.1
header("Pragma: no-cache"); // for HTTP/1.0

set_time_limit(120);

//$head_message = "<meta http-equiv=\"expires\" content=\"-1\">\n<meta http-equiv=\"pragma\" content=\"no-cache\">";

function gnuplot_data_line($record) {
	$rec = sprintf("%s\t",$record[packet_date]);
	$rec .= sprintf("%.2lf\t", cvrt($record["temperature"],"celfar",$_REQUEST["metric"]));
	$rec .= sprintf("%03d\t",$record["wind_direction"]);
	$rec .= sprintf("%.2lf\t",cvrt($record["wind_speed"],"kmmi",$_REQUEST["metric"]));
	$rec .= sprintf("%.2lf\t",cvrt($record["wind_gust"],"kmmi",$_REQUEST["metric"]));
	$rec .= sprintf("%2.3f\t",cvrt($record["rain_hour"],"cmin",$_REQUEST["metric"]));
	$rec .= sprintf("%2.3f\t",cvrt($record["rain_day"],"cmin",$_REQUEST["metric"]));
	$rec .= sprintf("%2.3f\t",cvrt($record["rain_midnight"],"cmin",$_REQUEST["metric"]));
	$rec .= sprintf("%.2f\t",cvrt($record["barometer"],"mbinhg",$_REQUEST["metric"]));
	$rec .= sprintf("%2d\n",$record["humidity"]);

	return $rec;
}

$call = strtoupper($_REQUEST["call"]);
$show_query = $_REQUEST["show_query"];
$start_date = $_REQUEST["start_date"];
$end_date = $_REQUEST["end_date"];

$headline = $title = "Weather plot for " . $call;
$hr=1;
require $_SERVER["DOCUMENT_ROOT"] . "/world_head.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/metric.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/stopwatch.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/units.php";


?>
<PRE>
<?

$db = open_mysql("aprs");


if ( "" == $start_date ) {
	$start_date = sprintf("'%s'",date("Y-m-d",time() - 604800));	/* current date - 1 week */
} else {
	$start_date = "'" . $start_date . "'";
}

if ( "" == $end_date ) {
	$end_date = "now()";
} else {
	$end_date = "'" . $end_date . "'";
}


$sql = sprintf("SELECT * FROM weather WHERE packet_date >= %s AND packet_date <= %s AND source='%s' ORDER BY packet_date",$start_date,$end_date,$call);
//$sql = sprintf("SELECT * FROM weather WHERE source='%s' ORDER BY packet_date",$call);

if ( 1 == $show_query )
	printf("MySQL = %s<BR>\n",$sql);

ss_timing_start();
$query = mysql_query($sql,$db);
ss_timing_stop();

$i=0;

$uniq = md5(uniqid($call));
$dat_filename_path = sprintf("%s/%s-WX-%s.dat",WX_TEMP_PATH,$call,$uniq );
$dat_filename_url  = sprintf("%s/%s-WX-%s.dat",WX_TEMP_URL, $call,$uniq );
$fp = fopen( $dat_filename_path,"w"); 

$header = sprintf("packet_date\ttemperature\twind_direction\twind_speed\twind_gust\train_hour\train_day\train_midnight\tbarometer\thumidity\n");
fputs($fp,$header);

while ( $record = mysql_fetch_array($query) )
	{
	$i++;

	fputs($fp,gnuplot_data_line($record));
}

fclose($fp);

?>
</PRE>
<?

if ( $i > 0 ) {
	/* don't display anything if we have zero records */
?>
<DIV ALIGN=CENTER>
<?
$type="temperature";
$this_graph = sprintf("/datamart/gnuplot/gnuplot.php?type=%s&amp;call=%s&amp;units=%s&amp;filename=%s",$type,$call,urlencode(getUnitByName($type,$_REQUEST["metric"])),$dat_filename_path);

?>
	<A HREF="<? echo $this_graph; ?>&amp;debug=1"><IMG SRC="<? echo $this_graph; ?>" ALT="Plot"></A>

	<HR>
<?



$type="wind_speed";
$this_graph = sprintf("/datamart/gnuplot/gnuplot.php?type=%s&amp;call=%s&amp;units=%s&amp;filename=%s",$type,$call,urlencode(getUnitByName($type,$_REQUEST["metric"])),$dat_filename_path);
?>
	<A HREF="<? echo $this_graph; ?>&amp;debug=1"><IMG SRC="<? echo $this_graph; ?>" ALT="Plot"></A>
	<HR>
<?
$type="humidity";
$this_graph = sprintf("/datamart/gnuplot/gnuplot.php?type=%s&amp;call=%s&amp;units=%s&amp;filename=%s",$type,$call,urlencode(getUnitByName($type,$_REQUEST["metric"])),$dat_filename_path);
?>
	<A HREF="<? echo $this_graph; ?>&amp;debug=1"><IMG SRC="<? echo $this_graph; ?>" ALT="Plot"></A>
	<HR>
<?
$type="wind_gust";
$this_graph = sprintf("/datamart/gnuplot/gnuplot.php?type=%s&amp;call=%s&amp;units=%s&amp;filename=%s",$type,$call,urlencode(getUnitByName($type,$_REQUEST["metric"])),$dat_filename_path);
?>
	<A HREF="<? echo $this_graph; ?>&amp;debug=1"><IMG SRC="<? echo $this_graph; ?>" ALT="Plot"></A>
	<HR>
<?
$type="barometer";
$this_graph = sprintf("/datamart/gnuplot/gnuplot.php?type=%s&amp;call=%s&amp;units=%s&amp;filename=%s",$type,$call,urlencode(getUnitByName($type,$_REQUEST["metric"])),$dat_filename_path);
?>
	<A HREF="<? echo $this_graph; ?>&amp;debug=1"><IMG SRC="<? echo $this_graph; ?>" ALT="Plot"></A>




</DIV>

You can download the data file <A HREF="<? echo $dat_filename_url; ?>"><? echo $dat_filename_url; ?></A> used to generate these graphs. These data are tab seperated and can easily be used with spreadsheets like Gnumeric or Excel. The individual GNUPlot definition files can be downloaded by clicking on the corresponding graph.

<? 
} else {
?>
No weather data found for the criteria specified!
<?
}
require $_SERVER["DOCUMENT_ROOT"] . "/world_foot.php";
?>
