<?

$call = $_REQUEST["call"];
$name = $_REQUEST["name"];
$lat = $_REQUEST["lat"];
$lon = $_REQUEST["lon"];
$maps = $_REQUEST["maps"];
$symbol_table = $_REQUEST["symbol_table"];
$symbol_code = $_REQUEST["symbol_code"];
$bbox_size = $_REQUEST["bbox_size"];
$sort = $_REQUEST["sort"];
$limit = $_REQUEST["limit"];
$offset = $_REQUEST["offset"];
$show_query = $_REQUEST["show_query"];


$call = strtoupper($call);
$headline = $title = sprintf("Stations near %s <NOBR>(%s %s)</NOBR>",$name,$lat,$lon);
$hr=1;
require "../world_head.php";
include "geoFunctions.php";
?>

<DIV ALIGN="center">
<TABLE BGCOLOR="#e0e0e0" WIDTH=90% CELLPADDING=2 CELLSPACING=2 BORDER=0">
<TR>
	<TH><!-- Icon --></TH>
	<TH>Callsign</TH>
	<TH>Date</TH>
	<TH>Course / Speed / Altitude</TH>
	<TH>Lat/Lon (WGS84)</TH>
	<TH>Status</TH>
	<TH>Distance</TH>
</TR>
<!--
$lat		Latitude to be near
$lon 		Longitude to be near
$bbox_size	Size of search area
$sort		column to order by, default source
$limit	maximum number of results to show, default 100
$offset	record to start at
$show_query	if 1 then show query
-->
<?
require "stopwatch.php";
require "icon.php";

$db = open_mysql("aprs");


if ( $sort == "" )
	$sort = "source";
if ( $limit == "" )
	$limit = 100;
if ( $offset == "" )
	$offset = 0;
if ( $bbox_size == "" )
	$bbox_size = .5;

/* Put us in the right hemisphere */
if ( $lat < 0 ) {
	$lat1 = $lat - $bbox_size;
	$lat2 = $lat + $bbox_size;
	$lat1_sign = ">=";
	$lat2_sign = "<=";
} else {
	$lat1 = $lat + $bbox_size;
	$lat2 = $lat - $bbox_size;
	$lat1_sign = "<=";
	$lat2_sign = ">=";
}
if ( $lon < 0 ) {
	$lon1 = $lon - $bbox_size;
	$lon2 = $lon + $bbox_size;
	$lon1_sign = ">=";
	$lon2_sign = "<=";
} else {
	$lon1 = $lon + $bbox_size;
	$lon2 = $lon - $bbox_size;
	$lon1_sign = "<=";
	$lon2_sign = ">=";
}

if ( $symbol_code!="" && $symbol_table!="" ) {
	$terms = sprintf(" AND symbol_code LIKE '%s' AND symbol_table LIKE '%s' ",$symbol_code,$symbol_table);
}

$query = sprintf("SELECT * FROM lastposition WHERE (latitude %s %s AND latitude %s %s) AND (longitude %s %s AND longitude %s %s) %s\n",$lat1_sign,$lat1,$lat2_sign,$lat2,$lon1_sign,$lon1,$lon2_sign,$lon2,$terms);


if ( 1 == $show_query )
	printf("MySQL = %s<BR>\n",$query);

ss_timing_start();
$q1 = mysql_query($query,$db);
ss_timing_stop();

$i=0;
while ( $record = mysql_fetch_array($q1) )
	{
	$data[$i]["source"] = $record["source"];
	$data[$i]["packet_date"] = $record["packet_date"];
	$data[$i]["packet_id"] = $record["packet_id"];
	$data[$i]["symbol_table"] = $record["symbol_table"];
	$data[$i]["symbol_code"] = $record["symbol_code"];
	$data[$i]["course"] = $record["course"];
	$data[$i]["speed"] = $record["speed"];
	$data[$i]["altitude"] = $record["altitude"];
	$data[$i]["latitude"] = $record["latitude"];
	$data[$i]["longitude"] = $record["longitude"];
	$data[$i]["status"] = urlToClickable($record["status"]);
	$data[$i]["arcLength"] = arcLength($lat,$lon,$data[$i]["latitude"],$data[$i]["longitude"]);
	$data[$i]["icon"] = get_icon_name($record["symbol_table"],$record["symbol_code"]);
	$i++;
}
$records = count($data);

if ( $records > 0 )
	usort($data, sortByDistance);

for ( $i=0 ; $i < $records && $i < $limit ; $i++ ) {
?>	  
<TR BGCOLOR="#ffffff">

	<TD ALIGN="center"><? echo get_icon_img_src($data[$i]["symbol_table"],$data[$i]["symbol_code"]); ?></TD>
	<TD ALIGN="center"><? echo stationDetailLink($data[$i]["source"]); ?></font></TD>
	<TD ALIGN="center"><? echo $data[$i]["packet_date"]; ?></TD>
	<TD ALIGN="center"><? 
if ( $data[$i][course] ) {
	printf("%03d /",$data[$i]["course"]);
} else {
	printf("??? /");
}

if ( $data[$i][speed] ) {
	printf(" %02d /",$data[$i]["speed"]);
} else {
	printf(" ??? /");
}

if ( $data[$i][altitude] ) {
	printf(" %d",$data[$i]["altitude"]);
} else {
	printf(" ???");
}
?></TD>
	<TD ALIGN="center"><? 
if ( $data[$i]["latitude"] == 0 && $data[$i]["longitude"] == 0 ) {
	printf("??? ???"); 
	} else { 
	printf("%2.4lf %2.4lf",$data[$i]["latitude"],$data[$i]["longitude"]); 
	}
?></TD>
	<TD><? echo $data[$i]["status"]; ?></TD>
	<TD ALIGN="center"><? printf("%.2fmi",$data[$i]["arcLength"]); ?></TD>
</TR>
<?
}
?>
<TR>
	<TH COLSPAN=7><FONT COLOR="white">There were <? echo $i; ?> records found in <? printf("%1.4lf",ss_timing_current()); ?> seconds.</FONT></TH>
</TR>
</TABLE>
</DIV>
<? 
require "../world_foot.php";
?>
