<?
$title=$headline="Count of APRS Symbols Used";
require "../world_head.php";
require "icon.php";

$db = open_mysql("aprs");

$sql = "SELECT symbol_table,symbol_code,count(packet_id) AS count FROM lastposition GROUP BY symbol_table,symbol_code";
$query = mysql_query($sql,$db);

$total = mysql_num_rows($query);
$cols=5;
?>
<DIV ALIGN=CENTER>
This shows the number of stations with a particular icon. By clicking on the icon you can display a list of those stations. It is sorted by order of popularity (left to right).
<BR>
<TABLE BORDER=1 CELLPADDING=1>
	<TR>
<?
	for ( $i=0 ; $i<$cols ; $i++ ) {
		printf("<TH COLSPAN=4>Column %d</TH>\n",$i);
}
?>
	</TR>
	<TR>
<?
	for ( $i=0 ; $i<$cols ; $i++ ) {
?>
		<TH>Icon</TH>
		<TH>T C</TH>
		<TH>Count</TH>
		<TH>%</TH>
<?
}
?>
	</TR>
	<TR CLASS="highlightone">
<?
/* Load results into an array so we can sort them */
$i=0;
while ( $line = mysql_fetch_array($query) ) {
	$rec[$i]["symbol_table"] = $line["symbol_table"];
	$rec[$i]["symbol_code"] = $line["symbol_code"];
	$rec[$i]["symbol_count"] = $line["count"];
	$i++;
}

function sortByCount($a, $b ) {
	if ( $a["symbol_count"] == $b["symbol_count"] )
		return 0;
	if ( $a["symbol_count"] > $b["symbol_count"] )
		return -1;
	if ( $a["symbol_count"] < $b["symbol_count"] )
		return 1;
}

/* Sort the array by count */
usort($rec, sortByCount);


$i=1;
$j=0;
$color=0;
while ( $j<$total ) {
	$symbol_table = $rec[$j]["symbol_table"];
	$symbol_code = $rec[$j]["symbol_code"];
	$symbol_count = $rec[$j]["symbol_count"];
	$j++;

	$symbol_image = getIconImgSrc($symbol_table,$symbol_code);

	if ( $symbol_image == "" )
		continue;
	
	$search_link = sprintf("station-list.php?limit=%d&amp;symbol_table=%s&amp;symbol_code=%s&amp;call=%s&amp;sort=packet_id&amp;order=desc",$symbol_count+100,urlencode($symbol_table),urlencode($symbol_code),urlencode("%"));

	printf("\t\t<TD><A HREF=\"%s\">%s</A></TD>",$search_link,$symbol_image);
	printf("<TD>%s %s</TD>",htmlspecialchars($symbol_table),htmlspecialchars($symbol_code));
	printf("<TD>%d</TD><TD>%01.2lf%%</TD>\n",$symbol_count,$symbol_count / $total);

	if ( 0==($i % $cols) ) {
		$i=0;
		printf("</TR>");
		if ( $color ) {
			printf("<TR CLASS=\"highlightone\">\n");
			$color=0;
		} else {
			printf("<TR CLASS=\"highlighttwo\">\n");
			$color=1;
		}
	}
	$i++;

}
for (  ; $i<=$cols ; $i++ ) {
?>
		<TD COLSPAN=4></TD>
<?
}
printf("\t</TR>\n");
?>
</TABLE>
</DIV>
<P>
This page was generated by selecting the icons in use by all stations on APRS. Invalid icons were discarded.
<P>
Here is the SQL code:
<BLOCKQUOTE>
<I><? echo htmlspecialchars($sql); ?>;</I>
</BLOCKQUOTE>



<?
require "../world_foot.php";
?>
