<?
$title=$headline="Weather Summary";

require $_SERVER["DOCUMENT_ROOT"] . "/world_head.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/geoFunctions.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/metric.php";

$db = open_mysql("aprs");

/* external variables we will use */
$source = $_REQUEST["call"];
$show_query = $_REQUEST["show_query"];
$metric = $_REQUEST["metric"];

function source2where($source) {
	/* allow multiple source callsigns seperated by a pipe symbol */
	$source_array = explode("|",$source);
	$source_array_count = count($source_array);
	$to="";
	for ( $i=0 ; $i<$source_array_count-1 ; $i++ ) {
		$to .= sprintf("source='%s' OR ",$source_array[$i]);
	}
	$to .= sprintf("source='%s' ",$source_array[$source_array_count-1]);
	return $to;
}

function alternatecolors($one, $two) {
	static $i=0;
	
	if ( $i ) {
		$i=0;
		return $one;
	}
	$i=1;
	return $two;
}


$sql = sprintf("SELECT source, count(packet_id) AS packets, min(temperature)  AS min_temp, max(temperature) AS max_temp, max(wind_speed) AS max_wind, max(wind_gust) AS max_gust, max(wind_sustained) AS max_sus, max(rain_hour) AS max_rain_hour, max(rain_calendar_day) AS max_rain_calendar_day, max(rain_24hour_day) AS max_rain_24hour_day, min(humidity) AS min_humidity, max(humidity) AS max_humidity, min(barometer) AS min_barometer, max(barometer) AS max_barometer, substring(packet_date,1,10) AS day FROM weather WHERE %s GROUP BY source,substring(packet_date,1,10) ORDER BY substring(packet_date,1,10),source",source2where($source));

if ( $show_query ) {
	printf("SQL Query: %s\n",htmlspecialchars($sql));
}
?>

<DIV ALIGN=CENTER>

<?
$query = mysql_query($sql,$db);

if ( $metric ) {
	printf("Using metric units.<BR>\n");
} else {
	printf("Using english units.<BR>\n");
}
?>

<TABLE CLASS="border" BORDER=1>
	<TR>
		<TH>Station</TH>
		<TH>Date</TH>
		<TH>Reports</TH>
		<TH>Mininimum<BR> Temperature</TH>
		<TH>Maximum<BR> Temperature</TH>
		<TH>Maximum<BR> Speed</TH>
		<TH>Maximum<BR> Gust</TH>
		<TH>Maximum<BR> Sust.</TH>
		<TH>Maximum<BR> Rain in Hour</TH>
		<TH>Maximum<BR> Rain since Midnight</TH>
		<TH>Maximum<BR> Rain in Day</TH>
		<TH>Minimum<BR> Relative Humdity</TH>
		<TH>Maximum<BR> Relative Humdity</TH>
		<TH>Minimum<BR> Barometer</TH>
		<TH>Maximum<BR> Barometer</TH>
	</TR>
<?
while ( $record = mysql_fetch_array($query) ) {
?>
	<TR CLASS="<? echo alternatecolors("highlightone","highlighttwo"); ?>">
		<TD><? printf("<A HREF=\"%s\">%s</A>", getWeatherLink($record["source"]), $record["source"]); ?></TD>
		<TD><? echo $record["day"]; ?></TD>
		<TD><? echo $record["packets"]; ?></TD>
		<TD><? printf("%2d",cvrt($record["min_temp"],"celfar",$metric)); ?></TD>
		<TD><? printf("%2d",cvrt($record["max_temp"],"celfar",$metric)); ?></TD>
		<TD><? printf("%2d",cvrt($record["max_wind"],"kmmi",$metric)); ?></TD>
		<TD><? printf("%2d",cvrt($record["max_gust"],"kmmi",$metric)); ?></TD>
		<TD><? printf("%2d",cvrt($record["max_sus"],"kmmi",$metric)); ?></TD>
		<TD><? printf("%01.2lf",cvrt($record["max_rain_hour"],"cmin",$metric)); ?></TD>
		<TD><? printf("%01.2lf",cvrt($record["max_rain_calendar_day"],"cmin",$metric)); ?></TD>
		<TD><? printf("%01.2lf",cvrt($record["max_rain_24hour_day"],"cmin",$metric)); ?></TD>
		<TD><? printf("%01d", $record["min_humidity"]); ?>%</TD>
		<TD><? printf("%01d", $record["max_humidity"]); ?>%</TD>
		<TD><? echo $record["min_barometer"]; ?></TD>
		<TD><? echo $record["max_barometer"]; ?></TD>

<?
}
?>
</TABLE>

</DIV>


<?
require $_SERVER["DOCUMENT_ROOT"] . "/world_foot.php";
?>
