<?
$call = $_REQUEST["call"];
$sort = $_REQUEST["sort"];
$limit = $_REQUEST["limit"];
$offset = $_REQUEST["offset"];
$show_query = $_REQUEST["show_query"];
$maps = $_REQUEST["maps"];
$max_age = $_REQUEST["max_age"];

/* check for multiple calls separated with | symbol */
$calls=explode("|",strtoupper($_REQUEST["call"]));
if ( 1 == count($calls) ) {
	$call=$calls[0];
} else {
	$call = sprintf("%s' OR lastweather.source LIKE ",$calls[0]); 
	for ( $i=1 ; $i<count($calls)-1 ; $i++ ) {
		$call .= sprintf("'%s' OR lastweather.source LIKE ",$calls[$i]);
	}
	$call .= sprintf("'%s",$calls[$i]);
}


/* set sane initial values */
if ( ""==$sort )
	$sort = "packet_id";
if ( 0==$limit )
	$limit = 50;
if ( 0==$offset )
	$offset = 0;
if ( 0==$max_age )
	$max_age=-1;


$headline = $title = sprintf("Weather results for %s",implode(" or ",$calls));
$refreshable=1; $refresh_period_min=60;
require $_SERVER["DOCUMENT_ROOT"] . "/world_head.php";

require $_SERVER["DOCUMENT_ROOT"] . "/datamart/geoFunctions.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/metric.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/units.php";
require $_SERVER["DOCUMENT_ROOT"] . "/datamart/icon.php";
?>
<DIV ALIGN="center">
Current date is <? echo gmdate2mysqltime(); ?>.
<?
/* print the javascript required to change zoom levels */
imageReplaceJavascript();

if ( $metric ) {
	printf("Using metric units.<BR>\n");
} else {
	printf("Using english units.<BR>\n");
}
?>
<TABLE CELLPADDING=2 CELLSPACING=2 BORDER=1>
<TR>
	<TH ROWSPAN=2>Callsign</TH>
	<TH ROWSPAN=2>Date<BR>UTC</TH>
	<TH ROWSPAN=2>Age</TH>
	<TH ROWSPAN=2>Temperature<BR><? echo getUnitByName("temperature",$metric); ?></TH>
	<TH COLSPAN=4>Wind (<? echo getUnitByName("speed",$metric); ?>)</TH>
	<TH COLSPAN=3>Rain (<? echo getUnitByName("length",$metric); ?>)</TH>
	<TH ROWSPAN=2>Barometer<BR><? echo getUnitByName("barometer",$metric); ?></TH>
	<TH ROWSPAN=2>Relative Humidity</TH>
</TR>
<TR>
	<TH>Chill</TH>
	<TH>Direction</TH>
	<TH>Speed</TH>
	<TH>Gust</TH>
	<TH>Hour</TH>
	<TH>Day</TH>
	<TH>Midnight</TH>
</TR>
<!--
$call		Callsign to search for using LIKE
$sort		column to order by, default source
$limit	maximum number of results to show, default 1
$offset	record to start at
$show_query	if 1 then show query
-->
<?
require "stopwatch.php";



$db = open_mysql("aprs");

$sql = sprintf("SELECT lastweather.*, lastposition.latitude,lastposition.longitude,lastposition.symbol_table,lastposition.symbol_code,lastposition.status, sec_to_time(unix_timestamp()-unix_timestamp(lastweather.packet_date)) AS packet_age, unix_timestamp()-unix_timestamp(lastweather.packet_date) / 60 AS packet_age_minutes  FROM lastweather LEFT JOIN lastposition ON lastweather.source=lastposition.source WHERE lastweather.source LIKE '%s' ORDER BY lastweather.source",$call);

if ( $show_query )
	printf("MySQL: %s<BR>\n",htmlspecialchars($sql));

ss_timing_start();
$query = mysql_query($sql,$db);
ss_timing_stop();

$expiredStations=0;
$currentStations=0;
while ( $record = mysql_fetch_array($query) ) {
	if ( -1 != $max_age && $record["packet_age_minutes"] > $max_age )  {
		$expiredStations++;
		continue;
	}
	$currentStations++;

?>	  
<TR>
	<TD><? echo stationDetailLink($record["source"],$maps); ?></TD>
	<TD><? echo $record["packet_date"]; ?></TD>
	<TD><? echo $record["packet_age"]; ?></TD>
	<TD ALIGN="center"><? 
if ( "" != $record["temperature"] )
	printf("%d", cvrt($record["temperature"],"celfar",$metric)); 

?></TD>
	<TD ALIGN="center"><? 
if ( "" != $record["temperature"] && "" != $record["wind_speed"] )
	printf("%d", cvrt( windChill($record["temperature"],$record["wind_speed"]),"celfar",$metric)); 

?></TD>
	<TD ALIGN="center">
<? 
if ( "" != $record["wind_direction"] )
	printf("%03d&deg; %s",$record["wind_direction"],courseToCardinal($record["wind_direction"]));
?>
	</TD>
	<TD ALIGN="center">
<?
if ( "" != $record["wind_speed"] )
	printf("%2.0f",cvrt($record["wind_speed"],"kmmi",$metric));
?>
	</TD>
	<TD ALIGN="center">
<?
if ( "" != $record["wind_gust"] )
	printf("%2.0f",cvrt($record["wind_gust"],"kmmi",$metric));
?>
	</TD>
	<TD ALIGN="center">
<?
if ( "" != $record["rain_hour"] )
	printf("%2.3f",cvrt($record["rain_hour"],"cmin",$metric));
?>
	</TD>
	<TD ALIGN="center">
<?	
if ( "" != $record["rain_day"] )
	printf("%2.3f",cvrt($record[rain_day],"cmin",$metric));
?>
	</TD>
	<TD ALIGN="center">
<?
if ( "" != $record["rain_midnight"] )
	printf("%2.3f",cvrt($record[rain_midnight],"cmin",$metric));
?> 
	</TD>
	<TD ALIGN="center"><? 
if ( "" != $record["barometer"] )
	printf("%.2f",cvrt($record["barometer"],"mbinhg",$metric)); 
	?></TD>
	<TD ALIGN="center"><? 
if ( "" != $record["humditity"] )
	printf("%2d%%",$record["humidity"]);
	?></TD>
</TR>
<?
if ( $maps && $records<=20 && $record["latitude"] && $record["longitude"] ) {
$icon = get_icon_name($record["symbol_table"],$record["symbol_code"])
?>
<TR>
	<TD COLSPAN=13 ALIGN=CENTER>
		<? mapserverScaleableRadarMap($record["latitude"],$record["longitude"],$record["source"],$icon); ?>
	</TD>
</TR>
<?
}
?>

<TR>
	<TD COLSPAN=13>
<TABLE WIDTH="100%">
<? 
if ( "" != $record["status"] ) {
?>
	<TR CLASS="highlighttwo">
		<TD ALIGN="right">Status:</TD>
		<TD COLSPAN=5><? echo humanStatus($record,$metric) . $record["status"];?></TD>
	</TR>
<?
}
?>
	<TR CLASS="highlighttwo">
		<TD ALIGN="right">Geospatial:</TD>
		<TD>
<A HREF="<? printf("http://www.acme.com/mapper/?lat=%lf&amp;long=%lf&amp;theme=Image",$record["latitude"],$record["longitude"]); ?>">Satellite Photo</A>
		</TD>
		<TD>
<A HREF="<? echo mapserverImgUrl($record["latitude"],$record["longitude"],$record["source"],$record["icon"],"regional"); ?>">Regional Map</A>
		</TD>
		<TD>
<A HREF="<? echo mapserverImgUrl($record["latitude"],$record["longitude"],$record["source"],$record["icon"],"street"); ?>">Steet Map</A>
		</TD>
		<TD>
<A HREF="<? echo gazClosestPointUrl($record["latitude"],$record["longitude"],$record["source"]); ?>">Closest City</A>
		</TD>
		<TD>
<A HREF="<? echo getGeocodeLink($record["latitude"],$record["longitude"],$record["packet_id"]); ?>">GeoCode</A>
		</TD>
	</TR>
	<TR CLASS="highlighttwo">
		<TD ALIGN="right">Radio:</TD>
		<TD>
<A HREF="<? echo getWeatherPlot($record["source"]); ?>">Weather Plot</A>
		</TD>
		<TD>
<A HREF="<? echo datamartCloseStations($record["latitude"],$record["longitude"],$record["source"]); ?>">Nearby Stations</A>
		</TD>
		<TD>
<A HREF="<? echo rawTncUrl($record["packet_id"]); ?>">Raw Packet</A>
		</TD>
		<TD>
<A HREF="<? echo getQrzLink($record["source"]); ?>">QRZ Lookup</A>
		</TD>
	</TR>
</TABLE>
</TR>
<?
}	// end while loop
?>
<TR>
	<TH COLSPAN=13>
		There were <B><? echo $currentStations; ?></B> current stations found and <B><? echo $expiredStations; ?></B> expired stations found in <B><? printf("%1.4lf",ss_timing_current()); ?></B> seconds.
	</TH>
</TR>
</TABLE>
</DIV>

<?
if ( $expiredStations > 0 ) {
?>
<H3>Expired Weather Stations</H3>
There were <B><? echo $expiredStations; ?></B> expired stations shown whose age was older than <B><? echo $max_age; ?></B> minutes.
<? 
}

require $_SERVER["DOCUMENT_ROOT"] . "/world_foot.php";
?>
